/*
 * File:	ImagList.cc
 * Purpose:	wxImageList class implementation (wxXt)
 * Author:	Julian Smart, Robert
 * Created:	1997
 */

#ifdef __GNUG__
#pragma implementation "ImagList.h"
#endif
 
#define Uses_wxDC
#define Uses_wxGDI
#define Uses_wxMemoryDC
#define Uses_wxString 
#include "wx.h"
 
#include "ImagList.h"

wxImageList::wxImageList(void)
{
//  m_images.DeleteContents( TRUE );
  m_height = 32;
  m_width = 32;
};

wxImageList::~wxImageList(void)
{
};


int wxImageList::GetImageCount(void)
{
  return m_images.Number();
};

Bool wxImageList::Create( const int width, const int height, 
                          const Bool WXUNUSED(mask), const int WXUNUSED(initial) )
{
  m_height = height;
  m_width = width;
  return TRUE;
};

int wxImageList::Add( wxBitmap *bitmap, const wxBitmap *WXUNUSED(mask) )
{
/*
  wxBitmap *bm = new wxBitmap( m_height, m_width );
  wxMemoryDC destDC;
  destDC.SelectObject( bm );
  wxMemoryDC srcDC;
  srcDC.SelectObject( bitmap );
  srcDC.ScaleGDIClasses( TRUE );
  srcDC.SetUserScale( (float)bitmap->GetWidth() / (float)m_width,
                      (float)bitmap->GetWidth() / (float)m_width );
  destDC.Blit( 0, 0, bitmap->GetWidth(), bitmap->GetHeight(), &srcDC, 0, 0, wxCOPY );
  destDC.SelectObject( NULL );
  srcDC.SelectObject( NULL );
*/
  m_images.Append( bitmap );
  return m_images.Number();
};

int wxImageList::Add( wxBitmap *bitmap, const wxColour& WXUNUSED(maskColour) )
{
  m_images.Append( bitmap );
  return m_images.Number();
};

int wxImageList::Add( const wxIcon *WXUNUSED(icon) )
{
  return m_images.Number();
};

Bool wxImageList::Replace( const int WXUNUSED(index), const wxBitmap *WXUNUSED(bitmap), 
                           const wxBitmap *WXUNUSED(mask) )
{
  return TRUE;
};

Bool wxImageList::Replace( const int WXUNUSED(index), const wxIcon *WXUNUSED(icon) )
{
  return TRUE;
};

Bool wxImageList::Remove( const int index )
{
  wxNode *node = m_images.Nth( index );
  if (node) m_images.DeleteNode( node );
  return (node != NULL);
};

Bool wxImageList::RemoveAll(void)
{
  m_images.Clear();
  return TRUE;
};

Bool wxImageList::GetSize( const int index, int &width, int &height )
{
  wxNode *node = m_images.Nth( index );
  if (node)
  {
    wxBitmap *bm = (wxBitmap*)node->Data();
    width = bm->GetWidth();
    height = bm->GetHeight();
    return TRUE;
  }
  else
  {
    width = 0;
    height = 0;
    return FALSE;
  };
};

Bool wxImageList::Draw( const int index, wxDC &dc, 
                        const int x, const int y,
                        const int WXUNUSED(flags), const Bool WXUNUSED(solidBackground) )
{
  wxNode *node = m_images.Nth( index );
  if (!node) return FALSE;
  wxBitmap *bm = (wxBitmap*)node->Data();
/*
  wxMemoryDC memDC;
  if (bm->GetColourMap()) memDC.SetColourMap( bm->GetColourMap() );
  memDC.SelectObject( bm );
  dc.Blit( x, y, bm->GetWidth(), bm->GetHeight(), &memDC, 0, 0, wxCOPY );
  memDC.SetColourMap( NULL );
  memDC.SelectObject( NULL );
*/
  dc.DrawIcon( bm, x, y, TRUE );
  return TRUE;
};


