/*
 * Copyright: (C) 1997, GNU (Robert Roebling)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef DragAndDrop_h
#define DragAndDrop_h

#ifdef __GNUG__
#pragma interface
#endif

//-----------------------------------------------------------------------------
// classes
//-----------------------------------------------------------------------------

class wxDragCanvas;

//-----------------------------------------------------------------------------
//  constants and types
//-----------------------------------------------------------------------------

#define DndNotDnd	-1
#define DndUnknown	0
#define DndRawData	1
#define DndFile		2
#define	DndFiles	3
#define	DndText		4
#define DndDir		5
#define DndLink		6
#define DndExe		7
#define DndURL          8
#define DndMIME         9
#define DndEND		10

//-----------------------------------------------------------------------------
//  wxDragCanvas
//-----------------------------------------------------------------------------

class wxDragCanvas : public wxCanvas
{
  DECLARE_DYNAMIC_CLASS(wxDragCanvas)

  private:
    Bool         isDragging;
    int          dragStartX,dragStartY;
    int          dragCounter;
    int          dndType;
    char        *dndData;
    int          dndSize;

  public:
    wxDragCanvas( void ) : 
      wxCanvas() {}; 
    wxDragCanvas( wxWindow *parent, int x = -1, int y = -1, int width = -1, int height = -1, 
      long style = wxRETAINED, Constdata char *name= "DragCanvas" );
    virtual void OnEvent( wxMouseEvent &event );
    virtual void StartDragging( const int WXUNUSED(x), const int WXUNUSED(y) ) {};
    void AddDragString( char *s );
};

#endif // DragAndDrop_h
