/*
 * File:	listTest.cc
 * Purpose:	Tests wxListCtrl
 * Author:	Julian Smart, Robert Roebling
 * Created:	1997
 * Updated:	
 * Copyright:
 */

#ifdef __GNUG__
#pragma implementation
 "listTest.h"
#endif

#define  Uses_wxApp
#define  Uses_wxWindow
#define  Uses_wxButton
#define  Uses_wxCheckBox
#define  Uses_wxChoice
#define  Uses_wxFontDialog
#define  Uses_wxFrame
#define  Uses_wxMessage
#define  Uses_wxPanel
#define  Uses_wxRadioBox
#define  Uses_wxSlider
#define  Uses_wxText
#define  Uses_wxTextWindow
#define  Uses_wxCanvas
#define  Uses_wxMenu
#define  Uses_wxMenuBar
#define  Uses_wxHashTable
#define  Uses_wxString
#define  Uses_XtIntrinsic
#include "wx.h"

#include "WIN_listctrl.h"
#include "listTest.h"

#include "help.xpm"
#include "home.xpm"
#include "idea.xpm"
#include "lock.xpm"

// This statement initializes the whole application and calls OnInit
MyApp myApp;

// A macro needed for some compilers (AIX) that need 'main' to be defined
// in the application itself.
IMPLEMENT_WXWIN_MAIN

// `Main program' equivalent, creating windows and returning main app frame
wxFrame *MyApp::OnInit(void)
{
  // Create the main frame window
  MyFrame *frame = new MyFrame(NULL, "wxListCtrl Test", 50, 50, 450, 340);

  // Give it an icon
#ifdef wx_msw
  frame->SetIcon(new wxIcon("mondrian"));
#endif
#ifdef wx_x
  frame->SetIcon(new wxIcon("aiai.xbm"));
#endif

  // Make an image list containing large icons
  m_imageListNormal = new wxImageList(32, 32, TRUE);
  m_imageListSmall = new wxImageList(16, 16, TRUE);

/*
  wxIcon *icon = new wxIcon("icon1", wxBITMAP_TYPE_ICO_RESOURCE);
  m_imageListNormal->Add(icon);
  delete icon;
  icon = new wxIcon("icon2", wxBITMAP_TYPE_ICO_RESOURCE);
  m_imageListNormal->Add(icon);
  delete icon;
  icon = new wxIcon("icon3", wxBITMAP_TYPE_ICO_RESOURCE);
  m_imageListNormal->Add(icon);
  delete icon;
  icon = new wxIcon("icon4", wxBITMAP_TYPE_ICO_RESOURCE);
  m_imageListNormal->Add(icon);
  delete icon;
  icon = new wxIcon("icon5", wxBITMAP_TYPE_ICO_RESOURCE);
  m_imageListNormal->Add(icon);
  delete icon;
  icon = new wxIcon("icon6", wxBITMAP_TYPE_ICO_RESOURCE);
  m_imageListNormal->Add(icon);
  delete icon;
  icon = new wxIcon("icon7", wxBITMAP_TYPE_ICO_RESOURCE);
  m_imageListNormal->Add(icon);
  delete icon;
  icon = new wxIcon("icon8", wxBITMAP_TYPE_ICO_RESOURCE);
  m_imageListNormal->Add(icon);
  delete icon;
  icon = new wxIcon("icon9", wxBITMAP_TYPE_ICO_RESOURCE);
  m_imageListNormal->Add(icon);
  delete icon;
  
  icon = new wxIcon("iconsmall", wxBITMAP_TYPE_ICO_RESOURCE);
  m_imageListSmall->Add(icon);
  delete icon;
*/

  wxBitmap *bm = new wxBitmap( help_xpm );
  m_imageListNormal->Add( bm );
  m_imageListSmall->Add( bm );

  bm = new wxBitmap( home_xpm );
  m_imageListNormal->Add( bm );
  m_imageListSmall->Add( bm );

  bm = new wxBitmap( idea_xpm );
  m_imageListNormal->Add( bm );
  m_imageListSmall->Add( bm );

  bm = new wxBitmap( mini_lock_xpm );
  m_imageListNormal->Add( bm );
  m_imageListSmall->Add( bm );
  
  m_imageListNormal->Add( bm );
  m_imageListSmall->Add( bm );
  
  m_imageListNormal->Add( bm );
  m_imageListSmall->Add( bm );
  
  m_imageListNormal->Add( bm );
  m_imageListSmall->Add( bm );
  
    // Make a menubar
  wxMenu *file_menu = new wxMenu;

  file_menu->Append(LIST_LIST_VIEW, 		"&List view");
  file_menu->Append(LIST_REPORT_VIEW, 		"&Report view");
  file_menu->Append(LIST_ICON_VIEW, 		"&Icon view");
  file_menu->Append(LIST_ICON_TEXT_VIEW, 	"Icon view with &text");
  file_menu->Append(LIST_SMALL_ICON_VIEW, 	"&Small icon view");
  file_menu->Append(LIST_SMALL_ICON_TEXT_VIEW, 	"Small icon &view with text");
  file_menu->AppendSeparator();
  file_menu->Append(LIST_ABOUT, "&About");
  file_menu->Append(LIST_QUIT, "E&xit");
  wxMenuBar *menu_bar = new wxMenuBar;
  menu_bar->Append(file_menu, "&File");
  frame->SetMenuBar(menu_bar);

  // Make a panel with a message
  frame->m_listCtrl = new MyListCtrl(frame, 0, 0, 400, 200,
  		wxLC_LIST);
//  		wxLC_LIST|wxLC_USER_TEXT); // wxLC_USER_TEXT requires app to supply all text on demand
  frame->m_logWindow = new wxTextWindow(frame, 0, 0, 400, 200);

  wxLayoutConstraints *c = new wxLayoutConstraints;
  c->top.SameAs			(frame, wxTop);
  c->left.SameAs		(frame, wxLeft);
  c->right.SameAs		(frame, wxRight);
  c->height.PercentOf	(frame, wxHeight, 66);
  frame->m_listCtrl->SetConstraints(c);

  c = new wxLayoutConstraints;
  c->top.Below			(frame->m_listCtrl);
  c->left.SameAs		(frame, wxLeft);
  c->right.SameAs		(frame, wxRight);
  c->bottom.SameAs		(frame, wxBottom);
  frame->m_logWindow->SetConstraints(c);
  frame->SetAutoLayout(TRUE);

  for ( int i=0; i < 30; i++)
	{
		char buf[20];
		sprintf(buf, "Item %d", i);
		long tmp = frame->m_listCtrl->InsertItem(i, buf);
	}

  frame->m_listCtrl->RealizeChanges();
	
  frame->CreateStatusLine(3);
  frame->SetStatusText("", 0);
  frame->SetAutoLayout(TRUE);

  // Show the frame
  frame->Show(TRUE);
  
  // Return the main frame window
  return frame;
}

// My frame constructor
MyFrame::MyFrame(wxFrame *frame, char *title, int x, int y, int w, int h):
  wxFrame(frame, title, x, y, w, h)
{
	m_listCtrl = NULL;
	m_logWindow = NULL;
}

MyFrame::~MyFrame(void)
{
	delete myApp.m_imageListNormal;
	delete myApp.m_imageListSmall;
}

void MyFrame::OnMenuCommand(int cmd)
{
	switch ( cmd )
	{
		case LIST_QUIT:
			OnQuit();
			break;
		case LIST_LIST_VIEW:
			OnListView();
			break;
		case LIST_ICON_VIEW:
			OnIconView();
			break;
		case LIST_ICON_TEXT_VIEW:
			OnIconTextView();
			break;
		case LIST_SMALL_ICON_VIEW:
			OnSmallIconView();
			break;
		case LIST_SMALL_ICON_TEXT_VIEW:
			OnSmallIconTextView();
			break;
		case LIST_REPORT_VIEW:
			OnReportView();
			break;
		case LIST_ABOUT:
			OnAbout();
			break;

		default :
			break;
	}
}

void MyFrame::OnQuit(void)
{
  Close(TRUE);
}

void MyFrame::OnAbout(void)
{
  wxMessageBox("List test sample\nJulian Smart et Robert Roebling(c) 1997", "About list test", wxOK|wxCANCEL);
}

void MyFrame::OnListView(void)
{
	m_logWindow->Clear();
	m_listCtrl->DeleteAllItems();
	m_listCtrl->SetSingleStyle(wxLC_LIST);
    m_listCtrl->SetImageList(NULL, wxIMAGE_LIST_NORMAL);
    m_listCtrl->SetImageList(NULL, wxIMAGE_LIST_SMALL);

	for ( int i=0; i < 30; i++)
	{
		char buf[20];
		sprintf(buf, "Item %d", i);
		long tmp = m_listCtrl->InsertItem(i, buf);
	}
  m_listCtrl->RealizeChanges();
}

void MyFrame::OnReportView(void)
{
	m_logWindow->Clear();
	m_listCtrl->DeleteAllItems();
	m_listCtrl->SetSingleStyle(wxLC_REPORT);
    m_listCtrl->SetImageList(NULL, wxIMAGE_LIST_NORMAL);
    m_listCtrl->SetImageList(myApp.m_imageListSmall, wxIMAGE_LIST_SMALL);

	m_listCtrl->InsertColumn(0, "Column 1", wxLIST_FORMAT_LEFT, 140);
	m_listCtrl->InsertColumn(1, "Column 20000", wxLIST_FORMAT_LEFT, wxLIST_AUTOSIZE_USEHEADER );
	m_listCtrl->InsertColumn(2, "Column 3", wxLIST_FORMAT_LEFT, 140 );

	for ( int i=0; i < 30; i++)
	{
		char buf[20];
		sprintf(buf, "Item %d, col 1", i);
		long tmp = m_listCtrl->InsertItem(i, buf, 0);

		sprintf(buf, "Item %d, col 2", i);
		tmp = m_listCtrl->SetItem(i, 1, buf);

		sprintf(buf, "Item %d, col 3", i);
		tmp = m_listCtrl->SetItem(i, 2, buf);
	}
  m_listCtrl->RealizeChanges();
}

void MyFrame::OnIconView(void)
{
	m_logWindow->Clear();
	m_listCtrl->DeleteAllItems();
	m_listCtrl->SetSingleStyle(wxLC_ICON);
    m_listCtrl->SetImageList(myApp.m_imageListNormal, wxIMAGE_LIST_NORMAL);
    m_listCtrl->SetImageList(myApp.m_imageListSmall, wxIMAGE_LIST_SMALL);

	for ( int i=0; i < 9; i++)
	{
		long tmp = m_listCtrl->InsertItem(i, i);
	}
  m_listCtrl->RealizeChanges();
}

void MyFrame::OnIconTextView(void)
{
	m_logWindow->Clear();
	m_listCtrl->DeleteAllItems();
	m_listCtrl->SetSingleStyle(wxLC_ICON);
    m_listCtrl->SetImageList(myApp.m_imageListNormal, wxIMAGE_LIST_NORMAL);
    m_listCtrl->SetImageList(myApp.m_imageListSmall, wxIMAGE_LIST_SMALL);

	for ( int i=0; i < 9; i++)
	{
		char buf[20];
		sprintf(buf, "Label %d", i);
		long tmp = m_listCtrl->InsertItem(i, buf, i);
	}
  m_listCtrl->RealizeChanges();
}

void MyFrame::OnSmallIconView(void)
{
	m_logWindow->Clear();
	m_listCtrl->DeleteAllItems();
	m_listCtrl->SetSingleStyle(wxLC_SMALL_ICON);
    m_listCtrl->SetImageList(myApp.m_imageListNormal, wxIMAGE_LIST_NORMAL);
    m_listCtrl->SetImageList(myApp.m_imageListSmall, wxIMAGE_LIST_SMALL);

	for ( int i=0; i < 9; i++)
	{
		long tmp = m_listCtrl->InsertItem(i, 0);
	}
  m_listCtrl->RealizeChanges();
}

void MyFrame::OnSmallIconTextView(void)
{
	m_logWindow->Clear();
	m_listCtrl->DeleteAllItems();
	m_listCtrl->SetSingleStyle(wxLC_SMALL_ICON);
    m_listCtrl->SetImageList(myApp.m_imageListNormal, wxIMAGE_LIST_NORMAL);
    m_listCtrl->SetImageList(myApp.m_imageListSmall, wxIMAGE_LIST_SMALL);

	for ( int i=0; i < 9; i++)
	{
		long tmp = m_listCtrl->InsertItem(i, "Label", 0);
	}
  m_listCtrl->RealizeChanges();
}

// MyListCtrl

void MyListCtrl::OnBeginDrag(wxListEvent& event)
{
	if ( !myApp.GetTopWindow() )
		return;

	wxTextWindow *text = ((MyFrame *)myApp.GetTopWindow())->m_logWindow;
	if ( !text )
		return;

	ostream str(text);

	str << "OnBeginDrag\n";
	str.flush();
}

void MyListCtrl::OnBeginRDrag(wxListEvent& event)
{
	if ( !myApp.GetTopWindow() )
		return;

	wxTextWindow *text = ((MyFrame *)myApp.GetTopWindow())->m_logWindow;
	if ( !text )
		return;
	ostream str(text);

	str << "OnBeginRDrag\n";
	str.flush();
}

void MyListCtrl::OnBeginLabelEdit(wxListEvent& event)
{
	if ( !myApp.GetTopWindow() )
		return;

	wxTextWindow *text = ((MyFrame *)myApp.GetTopWindow())->m_logWindow;
	if ( !text )
		return;

	ostream str(text);

	str << "OnBeginLabelEdit\n";
	str.flush();
}

void MyListCtrl::OnEndLabelEdit(wxListEvent& event)
{
	if ( !myApp.GetTopWindow() )
		return;

	wxTextWindow *text = ((MyFrame *)myApp.GetTopWindow())->m_logWindow;
	if ( !text )
		return;

	ostream str(text);

	str << "OnEndLabelEdit\n";
	str.flush();
}

void MyListCtrl::OnDeleteItem(wxListEvent& event)
{
	if ( !myApp.GetTopWindow() )
		return;

	wxTextWindow *text = ((MyFrame *)myApp.GetTopWindow())->m_logWindow;
	if ( !text )
		return;

	ostream str(text);

	str << "OnDeleteItem\n";
	str.flush();
}

void MyListCtrl::OnGetInfo(wxListEvent& event)
{
	if ( !myApp.GetTopWindow() )
		return;

	wxTextWindow *text = ((MyFrame *)myApp.GetTopWindow())->m_logWindow;
	if ( !text )
		return;

	ostream str(text);

	str << "OnGetInfo (" << event.m_item.m_itemId << ", " << event.m_item.m_col << ")";
	if ( event.m_item.m_mask & wxLIST_MASK_STATE )
		str << " wxLIST_MASK_STATE";
	if ( event.m_item.m_mask & wxLIST_MASK_TEXT )
		str << " wxLIST_MASK_TEXT";
	if ( event.m_item.m_mask & wxLIST_MASK_IMAGE )
		str << " wxLIST_MASK_IMAGE";
	if ( event.m_item.m_mask & wxLIST_MASK_DATA )
		str << " wxLIST_MASK_DATA";
	if ( event.m_item.m_mask & wxLIST_SET_ITEM )
		str << " wxLIST_SET_ITEM";
	if ( event.m_item.m_mask & wxLIST_MASK_WIDTH )
		str << " wxLIST_MASK_WIDTH";
	if ( event.m_item.m_mask & wxLIST_MASK_FORMAT )
		str << " wxLIST_MASK_WIDTH";

	if ( event.m_item.m_mask & wxLIST_MASK_TEXT )
	{
		event.m_item.m_text = "My callback text";
	}
	str << "\n";
	str.flush();
}

void MyListCtrl::OnSetInfo(wxListEvent& event)
{
	if ( !myApp.GetTopWindow() )
		return;

	wxTextWindow *text = ((MyFrame *)myApp.GetTopWindow())->m_logWindow;
	if ( !text )
		return;

	ostream str(text);

	str << "OnSetInfo\n";
	str.flush();
}

void MyListCtrl::OnSelected(wxListEvent& event)
{
	if ( !myApp.GetTopWindow() )
		return;

	wxTextWindow *text = ((MyFrame *)myApp.GetTopWindow())->m_logWindow;
	if ( !text )
		return;

	ostream str(text);

	str << "OnSelected\n";
	str.flush();
}

void MyListCtrl::OnDeselected(wxListEvent& event)
{
	if ( !myApp.GetTopWindow() )
		return;

	wxTextWindow *text = ((MyFrame *)myApp.GetTopWindow())->m_logWindow;
	if ( !text )
		return;

	ostream str(text);

	str << "OnDeselected\n";
	str.flush();
}

void MyListCtrl::OnKeyDown(wxListEvent& event)
{
	if ( !myApp.GetTopWindow() )
		return;

	wxTextWindow *text = ((MyFrame *)myApp.GetTopWindow())->m_logWindow;
	if ( !text )
		return;

	ostream str(text);

	str << "OnKeyDown\n";
	str.flush();
}

// OnListNotify de-multiplexes events and sends them to
// the above functions. Not necessary in wxWindows 2.0.
Bool MyListCtrl::OnListNotify(wxListEvent& event)
{
	switch ( event.GetEventType() )
	{
		case wxEVT_COMMAND_LIST_BEGIN_DRAG:
		{
			OnBeginDrag(event);
			break;
		};
		case wxEVT_COMMAND_LIST_BEGIN_RDRAG:
			OnBeginRDrag(event);
			break;
		case wxEVT_COMMAND_LIST_BEGIN_LABEL_EDIT:
			OnBeginLabelEdit(event);
			break;
		case wxEVT_COMMAND_LIST_END_LABEL_EDIT:
			OnEndLabelEdit(event);
			break;
		case wxEVT_COMMAND_LIST_DELETE_ITEM:
			OnDeleteItem(event);
			break;
/*
		case wxEVT_COMMAND_LIST_DELETE_ALL_ITEMS:
			OnDeleteAllItems(event);
			break;
*/
		case wxEVT_COMMAND_LIST_GET_INFO:
			OnGetInfo(event);
			break;
		case wxEVT_COMMAND_LIST_SET_INFO:
			OnSetInfo(event);
			break;
		case wxEVT_COMMAND_LIST_ITEM_SELECTED:
			OnSelected(event);
			break;
		case wxEVT_COMMAND_LIST_ITEM_DESELECTED:
			OnDeselected(event);
			break;
		case wxEVT_COMMAND_LIST_KEY_DOWN:
			OnKeyDown(event);
			break;
/*
		case wxEVT_COMMAND_LIST_INSERT_ITEM:
			OnInsertItem(event);
			break;
		case wxEVT_COMMAND_LIST_COL_CLICK:
			OnColClick(event);
			break;
*/
		default :
			break;
	}
	return TRUE;
}

