/*
 * listTest.h
 */

// Define a new application type
class MyApp: public wxApp
{ public:
    wxFrame *OnInit(void);

    wxImageList *m_imageListNormal;
    wxImageList *m_imageListSmall;
};

class MyListCtrl: public wxListCtrl
{
public:
   MyListCtrl(wxWindow *parent, int x, int y, int w, int h, long style):
        wxListCtrl(parent, x, y, w, h, style)
   {
   }

	void OnBeginDrag(wxListEvent& event);
	void OnBeginRDrag(wxListEvent& event);
	void OnBeginLabelEdit(wxListEvent& event);
	void OnEndLabelEdit(wxListEvent& event);
	void OnDeleteItem(wxListEvent& event);
	void OnGetInfo(wxListEvent& event);
	void OnSetInfo(wxListEvent& event);
	void OnSelected(wxListEvent& event);
	void OnDeselected(wxListEvent& event);
	void OnKeyDown(wxListEvent& event);

    // OnListNotify de-multiplexes events and sends them to
    // the above functions. Not necessary in wxWindows 2.0.
    virtual Bool OnListNotify(wxListEvent& event);
};

// Define a new frame type
class MyFrame: public wxFrame
{ public:
    MyListCtrl *m_listCtrl;
    wxTextWindow * m_logWindow;

    MyFrame(wxFrame *frame, char *title, int x, int y, int w, int h);
    ~MyFrame(void);
    
 public:
    void OnQuit(void);
    void OnAbout(void);
    void OnListView(void);
    void OnReportView(void);
    void OnIconView(void);
    void OnIconTextView(void);
    void OnSmallIconView(void);
    void OnSmallIconTextView(void);
	Bool OnClose(void) { return TRUE; }

    void OnMenuCommand(int id);
};


// ID for the menu quit command
#define LIST_QUIT 	                1
#define LIST_LIST_VIEW              2
#define LIST_ICON_VIEW              3
#define LIST_ICON_TEXT_VIEW         4
#define LIST_SMALL_ICON_VIEW        5
#define LIST_SMALL_ICON_TEXT_VIEW   6
#define LIST_REPORT_VIEW            7
#define LIST_ABOUT                  102

#define LIST_CTRL                   1000


